require "active_support/dependencies/autoload"
require "lookbook/engine"
require "lookbook/version"
require "view_component/engine"

module Lookbook
  extend ActiveSupport::Autoload

  autoload :Error, "lookbook/error"
  autoload :Utils, "lookbook/utils"
  autoload :Lang, "lookbook/lang"
  autoload :Params, "lookbook/params"
  autoload :TagOptions, "lookbook/tag_options"
  autoload :Page, "lookbook/page"
  autoload :Tag, "lookbook/tag"
  autoload :PageSection, "lookbook/page_section"
  autoload :PageCollection, "lookbook/page_collection"
  autoload :Features, "lookbook/features"
  autoload :Collection, "lookbook/collection"
  autoload :Entity, "lookbook/entity"
  autoload :Parser, "lookbook/parser"
  autoload :Preview, "lookbook/preview"
  autoload :PreviewCollection, "lookbook/preview_collection"
  autoload :PreviewController, "lookbook/preview_controller"
  autoload :PreviewExample, "lookbook/preview_example"
  autoload :PreviewGroup, "lookbook/preview_group"
  autoload :SourceInspector, "lookbook/source_inspector"
  autoload :TemplateParser, "lookbook/template_parser"
  autoload :CodeFormatter, "lookbook/code_formatter"
  autoload :Markdown, "lookbook/markdown"
  autoload :Theme, "lookbook/theme"
  autoload :Store, "lookbook/store"
  autoload :Component, "lookbook/component"
end
